# coding: utf8
#
# Copyright 2022 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-iscsi-target-discover-parameters.json
#
# Do not edit this file manually!
#

from __future__ import unicode_literals

from delphixpy.v1_11_8.web.objects.TypedObject import TypedObject
from delphixpy.v1_11_8 import common

class __Undef(object):
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

try:
    TEXT_TYPE = unicode
except NameError:
    TEXT_TYPE = str

class IscsiTargetDiscoverParameters(TypedObject):
    """
    *(extends* :py:class:`v1_11_8.web.vo.TypedObject` *)* Parameters for
    issuing an iSCSI SENDTARGETS Discovery operation.
    """
    def __init__(self, undef_enabled=True):
        super(IscsiTargetDiscoverParameters, self).__init__()
        self._type = ("IscsiTargetDiscoverParameters", True)
        self._portal = (self.__undef__, True)
        self._port = (self.__undef__, True)

    API_VERSION = "1.11.8"

    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super(IscsiTargetDiscoverParameters, cls).from_dict(data, dirty, undef_enabled)
        obj._portal = (data.get("portal", obj.__undef__), dirty)
        if obj._portal[0] is not None and obj._portal[0] is not obj.__undef__:
            assert isinstance(obj._portal[0], TEXT_TYPE), ("Expected one of ['string'], but got %s of type %s" % (obj._portal[0], type(obj._portal[0])))
            common.validate_format(obj._portal[0], "host", None, None)
        obj._port = (data.get("port", obj.__undef__), dirty)
        if obj._port[0] is not None and obj._port[0] is not obj.__undef__:
            assert isinstance(obj._port[0], int), ("Expected one of ['integer'], but got %s of type %s" % (obj._port[0], type(obj._port[0])))
            common.validate_format(obj._port[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super(IscsiTargetDiscoverParameters, self).to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "portal" == "type" or (self.portal is not self.__undef__ and (not (dirty and not self._portal[1]) or isinstance(self.portal, list) or belongs_to_parent)):
            dct["portal"] = dictify(self.portal)
        if "port" == "type" or (self.port is not self.__undef__ and (not (dirty and not self._port[1]) or isinstance(self.port, list) or belongs_to_parent)):
            dct["port"] = dictify(self.port)
        elif belongs_to_parent and self.port is self.__undef__:
            dct["port"] = 3260
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._portal = (self._portal[0], True)
        self._port = (self._port[0], True)

    def is_dirty(self):
        return any([self._portal[1], self._port[1]])

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, IscsiTargetDiscoverParameters):
            return False
        return super(IscsiTargetDiscoverParameters, self).__eq__(other) and \
               self.portal == other.portal and \
               self.port == other.port

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def portal(self):
        """
        The target portal's hostname or IP address.

        :rtype: ``TEXT_TYPE``
        """
        return self._portal[0]

    @portal.setter
    def portal(self, value):
        self._portal = (value, True)

    @property
    def port(self):
        """
        *(default value: 3260)* The target portal's port.

        :rtype: ``int``
        """
        return self._port[0]

    @port.setter
    def port(self, value):
        self._port = (value, True)

